//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnitMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;



void __fastcall TForm1::UpdateDisplay(void)
{
	int i,j,r,g,b,rg,gg,bg;
	unsigned char *srcg,*srcp,*dst1,*dst2;
	bool add,sub,picture,white,black;

	add    =SpeedButtonAdd->Down;
	sub    =SpeedButtonSub->Down;
	picture=SpeedButtonPicture->Down;
	white  =SpeedButtonWhite->Down;
	black  =SpeedButtonBlack->Down;

	for(i=0;i<224;++i)
	{
		srcg=(unsigned char*)ImageGradient->Picture->Bitmap->ScanLine[i];
		srcp=(unsigned char*)ImagePicture ->Picture->Bitmap->ScanLine[i];

		dst1=(unsigned char*)ImageDisplay->Picture->Bitmap->ScanLine[i*2+0];
		dst2=(unsigned char*)ImageDisplay->Picture->Bitmap->ScanLine[i*2+1];

		bg=*srcg++&0xf8;
		gg=*srcg++&0xf8;
		rg=*srcg  &0xf8;

		for(j=0;j<256;++j)
		{
			if(picture)
			{
				b=*srcp++&0xf8;
				g=*srcp++&0xf8;
				r=*srcp++&0xf8;
			}

			if(white)
			{
				b=0xf8;
				g=0xf8;
				r=0xf8;
			}

			if(black)
			{
				b=0;
				g=0;
				r=0;
			}

			if(add)
			{
				r+=rg;
				g+=gg;
				b+=bg;

				if(r>0xff) r=0xff;
				if(g>0xff) g=0xff;
				if(b>0xff) b=0xff;
			}

			if(sub)
			{
				r-=rg;
				g-=gg;
				b-=bg;

				if(r<0) r=0;
				if(g<0) g=0;
				if(b<0) b=0;
			}

			*dst1++=b;
			*dst1++=g;
			*dst1++=r;
			*dst1++=b;
			*dst1++=g;
			*dst1++=r;

			*dst2++=b;
			*dst2++=g;
			*dst2++=r;
			*dst2++=b;
			*dst2++=g;
			*dst2++=r;
		}
	}

	ImageDisplay->Repaint();
}



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButtonGradientConvertClick(TObject *Sender)
{
	int i,j,k,y,n,m,r,g,b,col;
	int ptr,cnt,prev,wdt,hgt;
	AnsiString str;
	unsigned char* src;
	int pack_color[512];
	int pack_repeat[512];
	int row_len,index,pack_len;

	UpdateDisplay();

	if(CheckBoxAverageH->Checked) wdt=256; else wdt=1;
	
	hgt=UpDownHeight->Position;

	if(hgt>ImageGradient->Picture->Bitmap->Height) hgt=ImageGradient->Picture->Bitmap->Height;

	MemoOutput->Clear();

	/*for(j=0;j<3;j++)
		{
			Memo1->Lines->Add("hdmaGradient0List"+IntToStr(j)+":");

			str=" .db ";

			for(i=0;i<hgt;++i)
			{
				src=(unsigned char*)Image1->Picture->Bitmap->ScanLine[i];
				n=((src[j])>>3)|(0x80>>j);

				str+="$"+IntToHex(n,2);
				if(i<hgt-1) str+=",";
			}

			Memo1->Lines->Add(str);
		}*/

	pack_len=0;
	prev=-1;
	cnt=1;

	for(i=0;i<hgt;++i)
	{
		n=0;
		r=0;
		g=0;
		b=0;

		src=(unsigned char*)ImageGradient->Picture->Bitmap->ScanLine[i];

		for(j=0;j<wdt;++j)
		{
			r+=*src++;
			g+=*src++;
			b+=*src++;
		}

		r/=wdt;
		g/=wdt;
		b/=wdt;

		n=(n<<8)|((r>>3)|(0x80>>0));
		n=(n<<8)|((g>>3)|(0x80>>1));
		n=(n<<8)|((b>>3)|(0x80>>2));

		if(i==hgt-1||(i&&n!=prev))//||!CheckBoxPackData->Checked)
		{
			while(cnt)
			{
				if(cnt>127)
				{
					m=127;
					cnt-=127;
				}
				else
				{
					m=cnt;
					cnt=0;
				}

				pack_color [pack_len]=n;
				pack_repeat[pack_len]=m;

				++pack_len;
			}

			prev=n;
			cnt=1;
		}
		else
		{
			++cnt;
		}
	}

	if(RadioButtonTypeRGB3->Checked)
	{
		for(j=0;j<3;++j)
		{
			MemoOutput->Lines->Add("hdmaGradient"+EditName->Text+"List"+IntToStr(j)+":");

			row_len=0;
			str="";

			for(i=0;i<pack_len;++i)
			{
				if(row_len>=8)
				{
					MemoOutput->Lines->Add(str);
					row_len=0;
				}

				if(!row_len) str=" .db "; else str+=",";

				str+="$"+IntToHex(pack_repeat[i],2)+",$"+IntToHex((pack_color[i]>>(j<<3))&0xff,2);

				++row_len;
			}

			MemoOutput->Lines->Add(str);
			MemoOutput->Lines->Add(" .db $00");
			MemoOutput->Lines->Add("");
		}
	}

	if(RadioButtonTypeRGB2->Checked)
	{
		MemoOutput->Lines->Add("hdmaGradient"+EditName->Text+"List01:");

		row_len=0;
		str="";

		for(i=0;i<pack_len;++i)
		{
			if(row_len>=5)
			{
				MemoOutput->Lines->Add(str);
				row_len=0;
			}

			if(!row_len) str=" .db "; else str+=",";

			str+="$"+IntToHex(pack_repeat[i],2)+",";
			str+="$"+IntToHex((pack_color[i]>>(0<<3))&0xff,2)+",";
			str+="$"+IntToHex((pack_color[i]>>(1<<3))&0xff,2);

			++row_len;
		}

		MemoOutput->Lines->Add(str);
		MemoOutput->Lines->Add(" .db $00");
		MemoOutput->Lines->Add("");

		MemoOutput->Lines->Add("hdmaGradient"+EditName->Text+"List2:");

		row_len=0;
		str="";

		for(i=0;i<pack_len;++i)
		{
			if(row_len>=8)
			{
				MemoOutput->Lines->Add(str);
				row_len=0;
			}

			if(!row_len) str=" .db "; else str+=",";

			str+="$"+IntToHex(pack_repeat[i],2)+",";
			str+="$"+IntToHex((pack_color[i]>>(2<<3))&0xff,2);

			++row_len;
		}

		MemoOutput->Lines->Add(str);
		MemoOutput->Lines->Add(" .db $00");
		MemoOutput->Lines->Add("");
	}

	if(RadioButtonTypeGray1->Checked)
	{
		MemoOutput->Lines->Add("hdmaGradient"+EditName->Text+"List:");

		row_len=0;
		str="";

		for(i=0;i<pack_len;++i)
		{
			if(row_len>=8)
			{
				MemoOutput->Lines->Add(str);
				row_len=0;
			}

			if(!row_len) str=" .db "; else str+=",";

			str+="$"+IntToHex(pack_repeat[i],2)+",$"+IntToHex((pack_color[i]&0xff)|0xe0,2);

			++row_len;
		}

		MemoOutput->Lines->Add(str);
		MemoOutput->Lines->Add(" .db $00");
		MemoOutput->Lines->Add("");
	}

	if(RadioButtonTypePalette1->Checked)
	{
		MemoOutput->Lines->Add("hdmaGradient"+EditName->Text+"List:");

		index=UpDownColorIndex->Position;

		row_len=0;
		str="";

		for(i=0;i<pack_len;++i)
		{
			if(row_len>=3)
			{
				MemoOutput->Lines->Add(str);
				row_len=0;
			}

			if(!row_len) str=" .db "; else str+=",";

			col=pack_color[i]^0xffffff;

			r= col     &31;
			g=(col>>8 )&31;
			b=(col>>16)&31;

			col=r|(g<<5)|(b<<10);

			str+="$"+IntToHex(pack_repeat[i],2)+",$"+IntToHex(index,2)+",$"+IntToHex(index,2)+",";
			str+="$"+IntToHex(col&0xff,2)+",";
			str+="$"+IntToHex((col>>8)&0xff,2);

			++row_len;
		}

		MemoOutput->Lines->Add(str);
		MemoOutput->Lines->Add(" .db $00");
		MemoOutput->Lines->Add("");
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditHeightChange(TObject *Sender)
{
	UpDownHeight->Position=StrToIntDef(EditHeight->Text,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
	ImageDisplay->Picture->Bitmap=new Graphics::TBitmap();
	ImageDisplay->Picture->Bitmap->SetSize(256*2,224*2);
	ImageDisplay->Picture->Bitmap->PixelFormat=pf24bit;

	ImageGradient->Picture->Bitmap=new Graphics::TBitmap();
	ImageGradient->Picture->Bitmap->SetSize(256,224);
	ImageGradient->Picture->Bitmap->PixelFormat=pf24bit;

	ImagePicture->Picture->Bitmap=new Graphics::TBitmap();
	ImagePicture->Picture->Bitmap->SetSize(256,224);
	ImagePicture->Picture->Bitmap->PixelFormat=pf24bit;

	ImageDisplay->Picture->Bitmap->Canvas->Brush->Color=clBlack;
	ImageDisplay->Picture->Bitmap->Canvas->FillRect(TRect(0,0,ImageDisplay->Width,ImageDisplay->Height));

	ImageGradient->Picture->Bitmap->Canvas->Brush->Color=clBlack;
	ImageGradient->Picture->Bitmap->Canvas->FillRect(TRect(0,0,ImageGradient->Width,ImageGradient->Height));

	ImagePicture->Picture->Bitmap->Canvas->Brush->Color=clBlack;
	ImagePicture->Picture->Bitmap->Canvas->FillRect(TRect(0,0,ImagePicture->Width,ImagePicture->Height));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonAddClick(TObject *Sender)
{
	UpdateDisplay();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButtonTypeRGB3Click(TObject *Sender)
{
	SpeedButtonGradientConvertClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonGradientLoadClick(TObject *Sender)
{
	if(!OpenDialogGradient->Execute()) return;

	SpeedButtonGradientReloadClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonGradientReloadClick(TObject *Sender)
{
	if(!FileExists(OpenDialogGradient->FileName)) return;

	ImageGradient->Picture->LoadFromFile(OpenDialogGradient->FileName);

	SpeedButtonGradientConvertClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonToClipboardClick(TObject *Sender)
{
	MemoOutput->SelectAll();
	MemoOutput->CopyToClipboard();	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonLoadBackgroundClick(TObject *Sender)
{
	if(!OpenDialogBackground->Execute()) return;

	SpeedButtonReloadBackgroundClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonReloadBackgroundClick(TObject *Sender)
{
	if(!FileExists(OpenDialogBackground->FileName)) return;

	ImagePicture->Picture->LoadFromFile(OpenDialogBackground->FileName);

	SpeedButtonGradientConvertClick(Sender);	
}
//---------------------------------------------------------------------------

