//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TMemo *MemoOutput;
	TPanel *PanelTools;
	TImage *ImageGradient;
	TLabel *LabelName;
	TLabel *LabelHeight;
	TSpeedButton *SpeedButtonGradientConvert;
	TImage *ImagePicture;
	TImage *ImageDisplay;
	TSpeedButton *SpeedButtonAdd;
	TSpeedButton *SpeedButtonSub;
	TEdit *EditName;
	TRadioButton *RadioButtonTypeRGB3;
	TRadioButton *RadioButtonTypeRGB2;
	TRadioButton *RadioButtonTypeGray1;
	TEdit *EditHeight;
	TUpDown *UpDownHeight;
	TRadioButton *RadioButtonTypePalette1;
	TCheckBox *CheckBoxAverageH;
	TOpenDialog *OpenDialogGradient;
	TSpeedButton *SpeedButtonGradientLoad;
	TSpeedButton *SpeedButtonGradientReload;
	TOpenDialog *OpenDialogBackground;
	TSpeedButton *SpeedButtonLoadBackground;
	TSpeedButton *SpeedButtonReloadBackground;
	TSpeedButton *SpeedButtonToClipboard;
	TSpeedButton *SpeedButtonNone;
	TSpeedButton *SpeedButtonPicture;
	TSpeedButton *SpeedButtonWhite;
	TSpeedButton *SpeedButtonBlack;
	TEdit *EditColorIndex;
	TUpDown *UpDownColorIndex;
	TLabel *LabelToIndex;
	void __fastcall SpeedButtonGradientConvertClick(TObject *Sender);
	void __fastcall EditHeightChange(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SpeedButtonAddClick(TObject *Sender);
	void __fastcall RadioButtonTypeRGB3Click(TObject *Sender);
	void __fastcall SpeedButtonGradientLoadClick(TObject *Sender);
	void __fastcall SpeedButtonGradientReloadClick(TObject *Sender);
	void __fastcall SpeedButtonToClipboardClick(TObject *Sender);
	void __fastcall SpeedButtonLoadBackgroundClick(TObject *Sender);
	void __fastcall SpeedButtonReloadBackgroundClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
	void __fastcall UpdateDisplay(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
